## mkl-dnn 0.17~rc

=== tests/benchdnn/CMakeLists.txt ===
#===============================================================================
# Copyright 2017-2018 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================================================

file(GLOB_RECURSE HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/*.hpp
    )
file(GLOB_RECURSE SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp
    )
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/conv
    ${CMAKE_CURRENT_SOURCE_DIR}/ip
    ${CMAKE_CURRENT_SOURCE_DIR}/shuffle
    ${CMAKE_CURRENT_SOURCE_DIR}/reorder
    )

if(BENCHDNN_USE_RDPMC)
    add_definitions(-DBENCHDNN_USE_RDPMC)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
    append_if(WIN32 CMAKE_CXX_FLAGS "-Qprec-div")
    append_if(UNIX  CMAKE_CXX_FLAGS "-prec-div -fp-model precise")
endif()

if(UNIX AND NOT APPLE)
    find_library(LIBRT rt)
endif()
register_exe(benchdnn "${SOURCES}" "" "${LIBRT}")

file(COPY inputs DESTINATION .)

# register benchdnn test case
function(register_benchdnn_test name cmd)
    string(REPLACE " " ";" cmd ${cmd})
    string(REPLACE " " ";" ARGV2 "${ARGV2}")
    add_custom_target(${name}
        COMMAND ${cmd}
        COMMAND ${ARGV2} # if any
        DEPENDS benchdnn
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    )
    if(WIN32)
        set_property(TARGET ${name} PROPERTY ENVIRONMENT "PATH=${CTESTCONFIG_PATH}")
        configure_file(${CMAKE_SOURCE_DIR}/config_template.vcxproj.user ${name}.vcxproj.user @ONLY)
    endif()
endfunction()

register_benchdnn_test(test_conv "benchdnn -v1 --conv --batch=inputs/test_conv_all")
register_benchdnn_test(test_benchdnn_conv "benchdnn -v1 --conv --batch=inputs/test_conv_all")
register_benchdnn_test(test_benchdnn_deconv "benchdnn -v1 --deconv --batch=inputs/test_deconv_all")
register_benchdnn_test(test_benchdnn_rnn "benchdnn -v1 --rnn")
register_benchdnn_test(test_benchdnn_reorder "benchdnn --reorder --batch=inputs/reorder/test_default")
register_benchdnn_test(test_benchdnn_bnorm "benchdnn --bnorm  --batch=inputs/bnorm/test_bnorm_topo")
register_benchdnn_test(test_benchdnn_ip "benchdnn --ip --batch=inputs/ip/test_ip_all")
register_benchdnn_test(test_benchdnn_regression
    "benchdnn --conv --batch=inputs/test_conv_regression"
    "benchdnn --bnorm --batch=inputs/bnorm/test_bnorm_regressions"
    )

=== debian/changelog ===
mkl-dnn (0.17~rc-2) unstable; urgency=medium

  * Fix binary-all-only and binary-any-only builds. (Closes: #913591)

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 13 Nov 2018 04:17:12 +0000

mkl-dnn (0.17~rc-1) unstable; urgency=medium

  * New upstream version 0.17~rc
  * Refresh patches and symbols control file.
  * Mark mkl-dnn as Multi-Arch: same.
  * Remove README.Debian. The tips were outdated.
  * Add debian/not-installed to reduce dh_missing output.
  * Set -DARCH_OPT_FLAGS="" to avoid patching upstream cmake file.
  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 12 Nov 2018 07:54:45 +0000

mkl-dnn (0.16+git20180820.f51304a-1) experimental; urgency=low

  * Initial release. (Closes: #894411)

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 22 Aug 2018 04:57:35 +0000

=== debian/control ===
Source: mkl-dnn
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>
Build-Depends: debhelper (>=11~),
               cmake,
Build-Depends-Indep: doxygen,
                     graphviz,
Standards-Version: 4.2.0
Homepage: https://github.com/intel/mkl-dnn
Vcs-Browser: https://salsa.debian.org/science-team/mkl-dnn
Vcs-Git: https://salsa.debian.org/science-team/mkl-dnn.git

# Note, the Architecture of this package is set to amd64 only as suggested
# by upstream. https://github.com/intel/mkl-dnn/issues/206

Package: libmkldnn-dev
Section: libdevel
Architecture: amd64
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libmkldnn0 (= ${binary:Version}),
Description: Intel Math Kernel Library for Deep Neural Networks (dev)
 Intel(R) Math Kernel Library for Deep Neural Networks (Intel(R) MKL-DNN) is
 an open source performance library for deep learning applications. The library
 accelerates deep learning applications and framework on Intel(R) architecture.
 Intel(R) MKL-DNN contains vectorized and threaded building blocks which you
 can use to implement deep neural networks (DNN) with C and C++ interfaces.
 .
 DNN functionality optimized for Intel architecture is also included in
 Intel(R) Math Kernel Library (Intel(R) MKL). API in this implementation
 is not compatible with Intel MKL-DNN and does not include certain new and
 experimental features.
 .
 One can choose to build Intel MKL-DNN without binary dependency. The resulting
 version will be fully functional, however performance of certain convolution
 shapes and sizes and inner product relying on SGEMM function may be suboptimal.
 .
 This package contains the header files, and symbol links to the shared object.

Package: libmkldnn0
Section: libs
Architecture: amd64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: Intel Math Kernel Library for Deep Neural Networks (lib)
 Intel(R) Math Kernel Library for Deep Neural Networks (Intel(R) MKL-DNN) is
 an open source performance library for deep learning applications. The library
 accelerates deep learning applications and framework on Intel(R) architecture.
 Intel(R) MKL-DNN contains vectorized and threaded building blocks which you
 can use to implement deep neural networks (DNN) with C and C++ interfaces.
 .
 DNN functionality optimized for Intel architecture is also included in
 Intel(R) Math Kernel Library (Intel(R) MKL). API in this implementation
 is not compatible with Intel MKL-DNN and does not include certain new and
 experimental features.
 .
 One can choose to build Intel MKL-DNN without binary dependency. The resulting
 version will be fully functional, however performance of certain convolution
 shapes and sizes and inner product relying on SGEMM function may be suboptimal.
 .
 This package contains the shared object.

Package: libmkldnn-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: Math Kernel Library for Deep Neural Networks (doc)
 Intel(R) Math Kernel Library for Deep Neural Networks (Intel(R) MKL-DNN) is
 an open source performance library for deep learning applications. The library
 accelerates deep learning applications and framework on Intel(R) architecture.
 Intel(R) MKL-DNN contains vectorized and threaded building blocks which you
 can use to implement deep neural networks (DNN) with C and C++ interfaces.
 .
 DNN functionality optimized for Intel architecture is also included in
 Intel(R) Math Kernel Library (Intel(R) MKL). API in this implementation
 is not compatible with Intel MKL-DNN and does not include certain new and
 experimental features.
 .
 One can choose to build Intel MKL-DNN without binary dependency. The resulting
 version will be fully functional, however performance of certain convolution
 shapes and sizes and inner product relying on SGEMM function may be suboptimal.
 .
 This package contains the doxygen documentation.

=== debian/tests/control ===
Test-Command: gcc $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c99 examples/simple_net.c -lmkldnn -o tester; ./tester
Depends: libmkldnn-dev, gcc

Test-Command: clang $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c99 examples/simple_net.c -lmkldnn -o tester; ./tester
Depends: libmkldnn-dev, clang

# --

Test-Command: g++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_net.cpp -lmkldnn -o tester; ./tester
Depends: libmkldnn-dev, g++

Test-Command: clang++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_net.cpp -lmkldnn -o tester; ./tester
Depends: libmkldnn-dev, clang

# -- the Int8 mode requires AVX512-bw instruction set to be supported by CPU.
#
#Test-Command: g++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_net_int8.cpp -lmkldnn -o tester; ./tester
#Depends: libmkldnn-dev, g++
#
#Test-Command: clang++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_net_int8.cpp -lmkldnn -o tester; ./tester
#Depends: libmkldnn-dev, clang

# -- the RNN tests needs MKL, which is still not available in Debian
#
#Test-Command: g++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_rnn.cpp -lmkldnn -o tester; ./tester
#Depends: libmkldnn-dev, g++
#
#Test-Command: clang++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_rnn.cpp -lmkldnn -o tester; ./tester
#Depends: libmkldnn-dev, clang

# --

Test-Command: gcc $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c99 examples/simple_training_net.c -lmkldnn -o tester; ./tester
Depends: libmkldnn-dev, gcc

Test-Command: clang $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c99 examples/simple_training_net.c -lmkldnn -o tester; ./tester
Depends: libmkldnn-dev, clang

# --

Test-Command: g++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_training_net.cpp -lmkldnn -o tester; ./tester
Depends: libmkldnn-dev, g++

Test-Command: clang++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_training_net.cpp -lmkldnn -o tester; ./tester
Depends: libmkldnn-dev, clang

## mkl-dnn 0.17

=== examples/CMakeLists.txt ===
#===============================================================================
# Copyright 2016-2018 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================================================

if (NOT WITH_EXAMPLE)
    return()
endif()

# propagate EXAMPLE specific flags
append(CMAKE_C_FLAGS "${CMAKE_EXAMPLE_CCXX_FLAGS}")
append(CMAKE_CXX_FLAGS "${CMAKE_EXAMPLE_CCXX_FLAGS}")

# propagate sanitizer flags
append(CMAKE_C_FLAGS "${CMAKE_CCXX_SANITIZER_FLAGS}")
append(CMAKE_CXX_FLAGS "${CMAKE_CCXX_SANITIZER_FLAGS}")

include_directories(${CMAKE_SOURCE_DIR}/include)

set_if(UNIX LIBM m)

register_exe(simple-net-c simple_net.c "test")
register_exe(simple-net-cpp simple_net.cpp "test")
register_exe(simple-training-net-c simple_training_net.c "test" ${LIBM})
register_exe(simple-training-net-cpp simple_training_net.cpp "test" ${LIBM})
register_exe(simple-net-int8-cpp simple_net_int8.cpp "test")

if(HAVE_MKL)
    register_exe(simple-rnn-cpp simple_rnn.cpp "test")
    register_exe(simple-rnn-training-cpp simple_rnn_training.cpp "test")
endif()

=== tests/CMakeLists.txt ===
#===============================================================================
# Copyright 2016-2018 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================================================

if (NOT WITH_TEST)
    return()
endif()

if(POLICY CMP0065)
    cmake_policy(SET CMP0065 NEW)
endif()

# propagate TEST specific flags
append(CMAKE_C_FLAGS "${CMAKE_TEST_CCXX_FLAGS}")
append(CMAKE_CXX_FLAGS "${CMAKE_TEST_CCXX_FLAGS}")

set(CMAKE_TEST_CCXX_NOWARN_FLAGS)

# propagate no warning flags
append(CMAKE_TEST_CCXX_NOWARN_FLAGS "${CMAKE_CCXX_NOWARN_FLAGS}")

# propagate sanitizer flags
append(CMAKE_C_FLAGS "${CMAKE_CCXX_SANITIZER_FLAGS}")
append(CMAKE_CXX_FLAGS "${CMAKE_CCXX_SANITIZER_FLAGS}")

# allow tests to include internal header files with, e.g.
# include "src/common/mkldnn_thread.hpp"
include_directories(${CMAKE_SOURCE_DIR})

if(UNIX OR MINGW)
    # workaround for Intel Compiler 16.0 that doesn't suppress warning on
    # deprecation with "-Wno-deprecated" compiler flag
    if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "17.0")
        append(CMAKE_TEST_CCXX_NOWARN_FLAGS "-diag-disable:1478")
    else()
        append(CMAKE_TEST_CCXX_NOWARN_FLAGS "-Wno-deprecated-declarations")
    endif()
elseif(WIN32 AND NOT MINGW)
    if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
        # 1478, 1786: deprecated functions
        append(CMAKE_TEST_CCXX_NOWARN_FLAGS "/Qdiag-disable:1478 /Qdiag-disable:1786")
    else()
        # c4244: conversion with possible loss of data
        # c4996: unsafe / deprecated functions
        append(CMAKE_TEST_CCXX_NOWARN_FLAGS "/wd4996 /wd4244")
    endif()
endif()

append(CMAKE_C_FLAGS "${CMAKE_TEST_CCXX_NOWARN_FLAGS}")
append(CMAKE_CXX_FLAGS "${CMAKE_TEST_CCXX_NOWARN_FLAGS}")

register_exe(api-c api.c "test")

if(UNIX OR MINGW)
    set(test_c_symbols "${CMAKE_CURRENT_BINARY_DIR}/test_c_symbols.c")
    add_custom_command(
        OUTPUT ${test_c_symbols}
        COMMAND /bin/bash ${CMAKE_CURRENT_SOURCE_DIR}/generate_c_symbols_refs.sh
        ${CMAKE_CURRENT_SOURCE_DIR}/.. ${test_c_symbols}
    )
    register_exe(test_c_symbols-c ${test_c_symbols} "test")
# elseif(WIN32)
# No Windows support for: test_c_symbols.c
endif()

add_subdirectory(gtests)
add_subdirectory(benchdnn)

=== tests/benchdnn/CMakeLists.txt ===
--- 
+++ 
@@ -72,3 +72,6 @@
     "benchdnn --conv --batch=inputs/test_conv_regression"
     "benchdnn --bnorm --batch=inputs/bnorm/test_bnorm_regressions"
     )
+register_benchdnn_test(test_benchdnn_regression_large
+    "benchdnn --bnorm --batch=inputs/bnorm/test_bnorm_regressions_large"
+    )

=== tests/gtests/CMakeLists.txt ===
#===============================================================================
# Copyright 2016-2018 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================================================

add_subdirectory (gtest)

set(APP_NAME "gtest")
set(MAIN_SRC_GTEST main.cpp)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/gtest
                    ${CMAKE_CURRENT_SOURCE_DIR}/in
                    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/common
                    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/cpu
                    )
if(WIN32)
    # Correct 'jnl' macro/jit issue
    if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
        append(CMAKE_CXX_FLAGS "/Qlong-double")
    endif()
endif()

# TODO: enable me!
file(GLOB PRIM_TEST_CASES_SRC
                              test_iface_pd_iter.cpp
                              test_iface_attr.cpp
                              test_mkldnn_threading.cpp
                              test_memory.cpp
                              test_sum.cpp
                              test_reorder.cpp
                              test_concat.cpp
                              test_softmax_forward.cpp
                              test_softmax_backward.cpp
                              test_eltwise.cpp
                              test_relu.cpp
                              test_lrn_forward.cpp
                              test_lrn_backward.cpp
                              test_pooling_forward.cpp
                              test_pooling_backward.cpp
                              test_batch_normalization.cpp
                              test_inner_product_forward.cpp
                              test_inner_product_backward_data.cpp
                              test_inner_product_backward_weights.cpp
                              test_shuffle.cpp
                              test_convolution_format_any.cpp
                              test_convolution_forward_f32.cpp
                              test_convolution_forward_s16s16s32.cpp
                              test_convolution_forward_u8s8s32.cpp
                              test_convolution_forward_u8s8fp.cpp
                              test_convolution_relu_forward_f32.cpp
                              test_convolution_relu_forward_neg_slope_f32.cpp
                              test_convolution_relu_forward_s16s16s32.cpp
                              test_convolution_backward_data_f32.cpp
                              test_convolution_backward_data_s16s16s32.cpp
                              test_convolution_backward_weights_f32.cpp
                              test_convolution_backward_weights_s16s16s32.cpp
                              test_deconvolution.cpp
                              test_gemm_f32.cpp
                              test_gemm_s8u8s32.cpp
                              test_gemm_s8s8s32.cpp
                              )

foreach(TEST_FILE ${PRIM_TEST_CASES_SRC})
    get_filename_component(TEST_FILE_WE ${TEST_FILE} NAME_WE)
    set(CURR_APP_NAME ${TEST_FILE_WE})
    register_exe(${CURR_APP_NAME} "${MAIN_SRC_GTEST};${TEST_FILE}" "test" "mkldnn_gtest")
endforeach()

# vim: et ts=4 sw=4

## mkl-dnn 0.17.1

=== debian/changelog ===
mkl-dnn (0.17.1-1) unstable; urgency=medium

  * New upstream version 0.17.1

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 02 Dec 2018 02:36:00 +0000

mkl-dnn (0.17-1) unstable; urgency=medium

  * New upstream version 0.17
  * Autopkgtest: add missing depends and allow output to stderr.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 23 Nov 2018 06:03:19 +0000

## mkl-dnn 0.17.2

=== debian/changelog ===
mkl-dnn (0.17.2-1) unstable; urgency=medium

  * New upstream version 0.17.2

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 22 Dec 2018 10:30:51 +0000

## mkl-dnn 0.17.3

=== CMakeLists.txt ===
#===============================================================================
# Copyright 2016-2018 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================================================

cmake_minimum_required(VERSION 2.8)

if(POLICY CMP0054)
    cmake_policy(SET CMP0054 NEW)
endif()

# Enable RPATH on MacOS/OSX
if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW)
endif()

# Do not export symbols from executables
if(POLICY CMP0065)
    cmake_policy(SET CMP0065 NEW)
endif()

# Pass all flags to try_compile
if(POLICY CMP0056)
    cmake_policy(SET CMP0056 NEW)
endif()
if(POLICY CMP0066)
    cmake_policy(SET CMP0066 NEW)
endif()

set(PROJECT_NAME "Intel(R) MKL-DNN")
set(PROJECT_FULL_NAME "Intel(R) Math Kernel Library for Deep Neural Networks (Intel(R) MKL-DNN)")
set(PROJECT_VERSION "0.17.3")

set(LIB_NAME mkldnn)

if (CMAKE_VERSION VERSION_LESS 3.0)
    project(${PROJECT_NAME} C CXX)
else()
    cmake_policy(SET CMP0048 NEW)
    project(${PROJECT_NAME} VERSION "${PROJECT_VERSION}" LANGUAGES C CXX)
endif()

if (NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    message("FATAL_ERROR" "Intel(R) MKL-DNN supports 64 bit platforms only")
endif()

if("${CMAKE_BUILD_TYPE}" STREQUAL "")
    message(STATUS "CMAKE_BUILD_TYPE is unset, defaulting to Release")
    set(CMAKE_BUILD_TYPE "Release")
endif()

set(CMAKE_SRC_CCXX_FLAGS)       # SRC specifics
set(CMAKE_EXAMPLE_CCXX_FLAGS)   # EXAMPLE specifics
set(CMAKE_TEST_CCXX_FLAGS)      # TESTS specifics

include("cmake/utils.cmake")
include("cmake/options.cmake")
include("cmake/OpenMP.cmake")
include("cmake/TBB.cmake")
include("cmake/platform.cmake")
include("cmake/SDL.cmake")
include("cmake/MKL.cmake")
include("cmake/Doxygen.cmake")
include("cmake/profiling.cmake")

enable_testing()

include_directories(include)

add_subdirectory(src)
add_subdirectory(examples)
add_subdirectory(tests)

install(FILES LICENSE DESTINATION share/doc/${LIB_NAME})

=== debian/changelog ===
mkl-dnn (0.17.3-1) unstable; urgency=medium

  * New upstream version 0.17.3
  * Bump Standards-Version to 4.3.0 (no change).

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 01 Feb 2019 06:55:19 +0000

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
export DEB_CFLAGS_MAINT_APPEND   = -Wall #-pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall #-pedantic
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

%:
	dh $@ -Scmake

override_dh_auto_configure:
	set -e; for item in $$(ls debian/*.install); do \
		sed -i -e "s@#DEB_HOST_MULTIARCH#@$(DEB_HOST_MULTIARCH)@g" $$item; \
		done
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DARCH_OPT_FLAGS=""

override_dh_auto_build-indep:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc
endif

override_dh_auto_install-indep:
	:
override_dh_auto_test-indep:
	:

override_dh_missing:
	dh_missing --list-missing

override_dh_installdocs:
	dh_installdocs -A doc/legal_information.md
	-dh_doxygen

## mkl-dnn 0.17.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 
 set(PROJECT_NAME "Intel(R) MKL-DNN")
 set(PROJECT_FULL_NAME "Intel(R) Math Kernel Library for Deep Neural Networks (Intel(R) MKL-DNN)")
-set(PROJECT_VERSION "0.17.3")
+set(PROJECT_VERSION "0.17.4")
 
 set(LIB_NAME mkldnn)

=== debian/changelog ===
mkl-dnn (0.17.4-1) unstable; urgency=medium

  * New upstream version 0.17.4

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 13 Feb 2019 07:55:46 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                cmake,
 Build-Depends-Indep: doxygen,
                      graphviz,
-Standards-Version: 4.2.0
+Standards-Version: 4.3.0
 Homepage: https://github.com/intel/mkl-dnn
 Vcs-Browser: https://salsa.debian.org/science-team/mkl-dnn
 Vcs-Git: https://salsa.debian.org/science-team/mkl-dnn.git

=== debian/tests/control ===
--- 
+++ 
@@ -1,16 +1,20 @@
 Test-Command: gcc $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c99 examples/simple_net.c -lmkldnn -o tester; ./tester
-Depends: libmkldnn-dev, gcc
+Depends: libmkldnn-dev, gcc, libc6-dev,
+Restrictions: allow-stderr
 
 Test-Command: clang $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c99 examples/simple_net.c -lmkldnn -o tester; ./tester
-Depends: libmkldnn-dev, clang
+Depends: libmkldnn-dev, clang, libc6-dev,
+Restrictions: allow-stderr
 
 # --
 
 Test-Command: g++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_net.cpp -lmkldnn -o tester; ./tester
 Depends: libmkldnn-dev, g++
+Restrictions: allow-stderr
 
 Test-Command: clang++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_net.cpp -lmkldnn -o tester; ./tester
 Depends: libmkldnn-dev, clang
+Restrictions: allow-stderr
 
 # -- the Int8 mode requires AVX512-bw instruction set to be supported by CPU.
 #
@@ -31,15 +35,19 @@
 # --
 
 Test-Command: gcc $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c99 examples/simple_training_net.c -lmkldnn -o tester; ./tester
-Depends: libmkldnn-dev, gcc
+Depends: libmkldnn-dev, gcc, libc6-dev,
+Restrictions: allow-stderr
 
 Test-Command: clang $(dpkg-buildflags --get CFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c99 examples/simple_training_net.c -lmkldnn -o tester; ./tester
-Depends: libmkldnn-dev, clang
+Depends: libmkldnn-dev, clang, libc6-dev,
+Restrictions: allow-stderr
 
 # --
 
 Test-Command: g++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_training_net.cpp -lmkldnn -o tester; ./tester
 Depends: libmkldnn-dev, g++
+Restrictions: allow-stderr
 
 Test-Command: clang++ $(dpkg-buildflags --get CXXFLAGS) $(dpkg-buildflags --get LDFLAGS) -std=c++11 examples/simple_training_net.cpp -lmkldnn -o tester; ./tester
 Depends: libmkldnn-dev, clang
+Restrictions: allow-stderr

## mkl-dnn 0.20

=== debian/changelog ===
mkl-dnn (0.20-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 08 Jul 2019 06:16:10 +0000

mkl-dnn (0.20-1~exp1) experimental; urgency=medium

  * New upstream version 0.20
  * Refresh symbol list.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 04 Jul 2019 14:09:04 +0000

mkl-dnn (0.19-1~exp1) experimental; urgency=medium

  * New upstream version 0.19

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 16 May 2019 05:35:08 +0000

mkl-dnn (0.18.1-1~exp1) experimental; urgency=medium

  * New upstream version 0.18.1

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 31 Mar 2019 14:52:02 +0000

mkl-dnn (0.18-1~exp1) experimental; urgency=medium

  * New upstream version 0.18
  * Update installation because upstream cmake adopted GNUInstallDir.
  * Install a new header file and CMake files for mkldnn.
  * Refresh symbols control file.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 04 Mar 2019 07:06:37 +0000

=== debian/rules ===
--- 
+++ 
@@ -8,9 +8,6 @@
 	dh $@ -Scmake
 
 override_dh_auto_configure:
-	set -e; for item in $$(ls debian/*.install); do \
-		sed -i -e "s@#DEB_HOST_MULTIARCH#@$(DEB_HOST_MULTIARCH)@g" $$item; \
-		done
 	dh_auto_configure -- \
 		-DCMAKE_BUILD_TYPE=Release \
 		-DARCH_OPT_FLAGS=""
